structure D = 
  struct 
     structure B = Boole
     structure P = Personen
     structure Z = Zeit
     structure O = Ort

     type zeit = Z.zeit
     type ort = O.ort
     type person = Personen.person

     type sit = zeit * ort

     (* Position von Individuen im Laufe der Zeit *)

     fun position (P.a) (t:zeit) = (5,5)
       | position (P.m) t = if t < 10 then (5,4) else (5,t)
       | position (P.e) t = if t = 5 then (t+1,5) else (t,t)
       | position (_:person) (t:zeit) = 
         if t < 10 then (t,0) else (t,1)

     (* Wertebereiche der syntaktischen Kategorien: *)
    
     type PN = person
     type NP = person
     type S = sit -> bool
     type N = person -> bool
     type N2 = person * person -> bool
     type IV = zeit -> (person -> bool) 
     type TV = zeit -> (person * person -> bool)
     type Pl = ort -> ort -> bool
   
     type ADVtq = (zeit -> bool) -> (zeit -> bool)
     type ADVtq2 = (zeit -> bool) * (zeit -> bool) -> (zeit -> bool)
     type ADVti = zeit -> zeit

     type ADVlq = (ort -> bool) -> (ort -> bool)
     type ADVld = zeit -> (ort -> bool)
     type ADVli = ort -> ort
  end

